/**
 * 	rmFx_msgTagging.js
 *
 	supports Thunderbird/MailApp messages tagging
	@since
		2009-11-01		SM2 support
		2009-07-27		TB2/TB3/PB support
<br>	2009-03-04		tag now can have uppercase letters, not sorted to top of list anymore
<br>	2008-04-14		deleting tag from message was adding it to the general tag-list
 */

function rmFx_msgTAGing(tagName, tagOp, tagColor, messageDBHDR) {

	switch (gRmFx_Messenger) {		
		case "TB2" : 
		case "TB3" :
		case "PB"  : 
		case "SM2" : 
		
			var tagService = Components.classes["@mozilla.org/messenger/tagservice;1"]
		                         .getService(Components.interfaces.nsIMsgTagService);                
			var xKey = tagService.getKeyForTag(tagName); 

			// add the tag to the tag-list if not already exists
			var exists = (!!xKey);
			
			if (exists == false) { 
 			  	 tagService.addTag(tagName, tagColor, '', true );	//  3. param is 'ordinal', leave blank
 			  	 													//  4. param is PostBox addition 
			}
			
	try {		// catch for PB with messages on IMAP -- timing issue ??
			if (messageDBHDR == null) { // if NO Hdr data, then used standard ToggleMessageTag
				//gWPB -- need for PB/IMAP handling 
				try { 
					ToggleMessageTag(xKey, tagOp, "", false)  // use tagName to get key, third param for PB
				} catch (ex) {}
			} else { 						//  else, we have the msg-URI
				rmFx_msgTagwHdr(tagName, tagOp, messageDBHDR)
			}
	}catch (ex) {}
	
			break;
			
	//	msg = ("RmFx_wRm: Tagging error\n\n" + e);
	//	rmFxCore.PromptAlert (msg);	                         
	}
}

   /**
    *  'tag' ONE msg, if the msgHdr is known
    *  
<br>*  //		 messageDBHDR.messageKey = [integer] 1499427
<br>*  //		 selectedMsgUris[0] = [string] "mailbox-message://nobody@Local%20Folders/Sent#1499427"
    */
function XXXXrmFx_msgTagwHdr(key, tagOp, msgHdr) 
{
	var messages 	= Components.classes["@mozilla.org/supports-array;1"].createInstance(Components.interfaces.nsISupportsArray);
	var msg 			= Components.classes["@mozilla.org/supports-array;1"].createInstance(Components.interfaces.nsISupportsArray);

	var toggler = tagOp ? "addKeywordsToMessages" : "removeKeywordsFromMessages";
	var prevHdrFolder = null;

	if (msgHdr.label)		// remove TB 1.5 header labels
	{
		msg.Clear();
	   msg.AppendElement(msgHdr);
	   msgHdr.folder.addKeywordsToMessages(msg, "$label" + msgHdr.label);
	   msgHdr.label = 0; // remove legacy label
	}
	messages.Clear();
	prevHdrFolder = msgHdr.folder;
	messages.AppendElement(msgHdr);
	prevHdrFolder[toggler](messages, key);
}


function rmFx_msgTagwHdr(key, addKey, messageHdr)
{
  var messages = Components.classes["@mozilla.org/array;1"].createInstance(Components.interfaces.nsIMutableArray);
  var msg = Components.classes["@mozilla.org/array;1"].createInstance(Components.interfaces.nsIMutableArray);


  // var selectedMessages = gFolderDisplay.selectedMessages;


  var toggler = addKey ? "addKeywordsToMessages" : "removeKeywordsFromMessages";
  var prevHdrFolder = null;

    var msgHdr = messageHdr;
    if (msgHdr.label)
    {
      // Since we touch all these messages anyway, migrate the label now.
      // If we don't, the thread tree won't always show the correct tag state,
      // because resetting a label doesn't update the tree anymore...
      msg.clear();
      msg.appendElement(msgHdr, false);
      msgHdr.folder.addKeywordsToMessages(msg, "$label" + msgHdr.label);
      msgHdr.label = 0; // remove legacy label
    }
    if (prevHdrFolder != msgHdr.folder)
    {
      if (prevHdrFolder)
        prevHdrFolder[toggler](messages, key);
      messages.clear();
      prevHdrFolder = msgHdr.folder;
    }
    messages.appendElement(msgHdr, false);

  if (prevHdrFolder)
    prevHdrFolder[toggler](messages, key);
  OnTagsChange();
}
